
--_NextPart_000_0002_01C3E1CC.3BB37320
Content-type: text/html;charset=UTF-8

//tmp/TopProcess.pl
--_NextPart_000_0002_01C3E1CC.3BB37320
Content-type: application/zip

########################################################################
# Introscope EPAgent Plugin Script                               
#                                                                      
# CA Wily Introscope(R) Version 9.1 Release 9.1.4.0
# Copyright (c) 2012 CA. All Rights Reserved.
# Introscope(R) is a registered trademark of CA.
#
########################################################################
# TopProcess.pl 
# ------------
# This Plugin Script returns metrics containing information
# about the top process by CPU or Memory utilization.
#
# Example: perl TopProcess.pl
#
########################################################################

#import our modules
use FindBin;
use lib ("$FindBin::Bin", "$FindBin::Bin/../lib/perl");
use Wily::PrintMetric;

use strict;

# Build the Top Process command with the proper arguments
# my $TopCPUCmd = 'prstat -S cpu -n 5';
# my $TopCPUCmd = '/usr/ucb/ps aux | head -10';
my $TopCPUCmd = "ps -eo 'user,pcpu,rss,pid,comm' | sort -k 2 -nr | head -10";
my $TopRSSCmd = "ps -eo user,rss,pcpu,pid,comm | sort -k 2 -nr | head -10";

# Get the prstat stats
my @TopCPUResults = `$TopCPUCmd`;
# Get rid of the header lines for command
# @TopCPUResults = @TopCPUResults[1..$#TopCPUResults];

my $count=0;

# Compile all the disk names reported in df
foreach my $j (@TopCPUResults) {
  # get rid of any trailing \n char
  chomp $j;
  my @line = split(' ', $j);
  my $pid = $line[3];
  my $user = $line[0];
  my $cpu = $line[1];
  my $proc_cmd = $line[4];
 #$count=$count+1;
  #print "\n";


Wily::PrintMetric::printMetric( type        => 'StringEvent',
                                resource    => 'TopCPU',
                                subresource => "$proc_cmd",
                                name        => "user_$user",
				value  	    => $user,
		               );

Wily::PrintMetric::printMetric(type        => 'PerIntervalCounter',
				resource    => 'TopCPU',
                                subresource => "$proc_cmd",
                                name        => "pid$pid",
				value  	    => int ($cpu),
		               );
}

# Get the prstat stats
my @TopRSSResults = `$TopRSSCmd`;
$count=0;

foreach my $j (@TopRSSResults) {
  # get rid of any trailing \n char
  chomp $j;
  my @line = split(' ', $j);
  my $pid = $line[3];
  my $user = $line[0];
  my $rss = $line[1];
  my $proc_cmd = $line[4];
  #$count=$count+1;
  #print $pid;
  #print $user;
  #print $cpu;
  #print $proc_cmd;
  #print $count;
  #print "\n";


Wily::PrintMetric::printMetric( type        => 'StringEvent',
                                resource    => 'TopRSS',
                                subresource => "$proc_cmd",
                                name        => "user_$user",
                                value       => $user,
                               );

Wily::PrintMetric::printMetric( type        => 'PerIntervalCounter',
                                resource    => 'TopRSS',
                                subresource => "$proc_cmd",
                                name        => "pid$pid",
                                value       => int ($rss/1024),
                               );

}

--_NextPart_000_0002_01C3E1CC.3BB37320--
